%define	name	parted
%define	version	1.6.25.1
%define	release	1

Summary:	flexible partitioning tool
Name:		%{name}
Version:	%{version}
Release:	%{release}
Copyright:	GPL
Group:		Applications/System
Vendor:		Andrew Clausen <clausen@gnu.org>
URL:		http://www.gnu.org/software/parted
Source:		ftp://ftp.gnu.org/gnu/%{name}/%{name}-%{version}.tar.gz
Source1:	ftp://ftp.gnu.org/gnu/%{name}/%{name}-%{version}.tar.gz.sig
Buildroot:	%{_tmppath}/%{name}-%{version}-root
Requires:	e2fsprogs
BuildPrereq:	e2fsprogs-devel
Conflicts:	%{name} < 1.2.0
Provides:	libparted-%{libver}

%description
GNU Parted is a program that allows you to create, destroy,
resize, move and copy hard disk partitions. This is useful for
creating space for new operating systems, reorganising disk
usage, and copying data to new hard disks.

%package	devel
Summary:	files required to compile software that uses libparted
Group:		Development/System
Requires:	e2fsprogs
BuildPrereq:	e2fsprogs-devel
Conflicts:	%{name}-devel < 1.2.0

%description	devel
This package includes the header files and libraries needed to
statically link software with libparted.

%package	boot
Summary:	flexible partitioning tool
Group:		Applications/System
Requires:	e2fsprogs
BuildPrereq:	e2fsprogs-devel
Conflicts:	%{name}-boot < 1.2.0

%description	boot
This package includes a stripped down version of parted that can be used
as part of a boot/rescue disk.

This is just the binary. Renamed to parted-boot.

%prep
%setup -q

%build
# Build boot version first.
%configure --without-readline \
	--disable-nls \
	--disable-shared \
	--enable-all-static
%{__make}
mv parted/parted parted/parted-boot;

# DistClean to insure clean build of normal version.
%{__make} distclean

# Build complete version.
%configure
%{__make}

%install
[ -d ${RPM_BUILD_ROOT} ] && rm -rf ${RPM_BUILD_ROOT};
%{__make} DESTDIR=${RPM_BUILD_ROOT} install

install -s -m 755 parted/parted-boot ${RPM_BUILD_ROOT}%{_sbindir}

# Remove unneeded files.
rm ${RPM_BUILD_ROOT}%{_libdir}/libparted.la
rm ${RPM_BUILD_ROOT}%{_infodir}/dir

# Prep for rpm docs
cp ABOUT-NLS AUTHORS BUGS COPYING ChangeLog INSTALL NEWS README THANKS TODO doc
rm doc/Make*

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%clean
[ -d ${RPM_BUILD_ROOT} ] && rm -rf ${RPM_BUILD_ROOT};

%files
%defattr(-,root,root)
%doc doc/*
%{_sbindir}/parted
%{_sbindir}/partprobe
%{_libdir}/libparted*so*
%{_datadir}/locale/*/LC_MESSAGES/*
%{_datadir}/info/parted.info*
%{_mandir}/*/parted.8*
%{_mandir}/*/*/parted.8*
%{_mandir}/*/partprobe.8*

%files devel
%defattr(-,root,root)
%{_datadir}/aclocal/parted.m4
%{_includedir}/parted
%{_libdir}/libparted.a

%files boot
%defattr(-,root,root)
%{_sbindir}/parted-boot

%changelog
* Fri Nov 11 2005 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.25.1-1]
- 2005-10-28  Leslie Polzer <leslie.polzer@gmx.net>
- corrects API and BINARY age.

  [parted-1.6.25-1]
- 2005-10-28  Guillaume Knispel <k_guillaume@libertysurf.fr>
- libparted/fs_hfs/journal.c, libparted/fs_hfs/hfs.c: fix some exception
  messages.
- libparted/unit.c (ped_unit_format_custom): remove unused variable "result".
- 2005-10-25  Guillaume Knispel <k_guillaume@libertysurf.fr>
- libparted/disk_mac.c (_disk_add_part_map_entry): the function didn't
  work when mac_disk_data->last_part_entry_num was null (when the only
  existing partition is the partition table and the user destroy it).
- 2005-10-24  Guillaume Knispel <k_guillaume@libertysurf.fr>
- parted/parted.c (prefer_snap): incorrectly chose MOVE_STILL instead
  of MOVE_UP or MOVE_DOWN if both weren't activated.
- 2005-10-15  Guillaume Knispel <k_guillaume@libertysurf.fr>
- libparted/filesys.c (_probe_with_open): The file system was considered
  valid if the open method was not implemented. Now openable file systems
  are considered first (if one and only one is successfully opened,
  return it), then if only one non openable file system is remaining,
  return it (else return NULL).
- 2005-10-14  Guillaume Knispel <k_guillaume@libertysurf.fr>
- libparted/disk_dos.c (_log_meta_overlap_constraint): ignore inactive
  partitions.
- parted/parted.c (snap_to_boundaries): didn't reliably work since the
  range is variable, complete rewrite.
- parted/parted.c (try_snap): was called by snap_to_boundaries, removed.
- parted/parted.c (prefer_snap): new function called by snap_to_boundaries,
  detect if the sector should be snaped to the begining of the partition
  it belongs to, or to the end.
- 2005-10-13  Guillaume Knispel <k_guillaume@libertysurf.fr>
- libparted/disk_gpt.c (add_metadata_part): don't forget to free the
  constraint if adding the metadata partition failed.
- 2005-10-04  Guillaume Knispel <k_guillaume@libertysurf.fr>
- doc/parted.texi: Unit command description added, based on what
  was previously in 2.2 Using GNU Parted (which has been replaced
  by a reference to the unit command...). Also various fixes in
  @copying layout and some typos fixes.
- 2005-10-03  Otavio Salvador <otavio@debian.org>
- po/es.po: updated
- 2005-10-03  Guillaume Knispel <k_guillaume@libertysurf.fr>
- Applied patch from Colin Watson <cjwatson@debian.org>:
- libparted/linux.c (_device_get_part_path): check for devfs-style /disc
  without even testing if _have_devfs(), because udev can be used instead
  with the same behavior.
- 2005-10-02  Guillaume Knispel <k_guillaume@libertysurf.fr>
- Applied patch from Matt Zimmerman <mdz@debian.org>:
- include/parted/device.h: PED_DEVICE_UBD added in PedDeviceType.
- libparted/linux.c (_device_probe_type): recognize UML UBD devices.
- libparted/linux.c (linux_new): handle UML UBD devices.
- 2005-09-21  Guillaume Knispel <k_guillaume@libertysurf.fr>
- po/id.po: added (thanks to Arif E. Nugroho <arif_endro@yahoo.com>)
- po/es.po: updated
- doc/parted.8: updates from A. Costa <agcosta@gis.net>
- Applied patch from Otavio Salvador <otavio@debian.org>:
- libparted/disk_dos.c (probe_partition_for_geom): Fix compiler warnings
  while compiling with gcc 4.0.
- libparted/disk_sun.c (sun_read): bugfix - recognize partitions on sun
  disklabel.
- 2005-08-22  Guillaume Knispel <k_guillaume@libertysurf.fr>
- libparted/disk_dos.c (_align_logical_no_geom): removed
  _calc_min_logical_start() and use a true constraint instead, generated by
  the new _log_meta_overlap_constraint(). This constraint should enforce
  necessary gaps between logical partitions to fit the linked list of
  partition tables. This should get ride of the infamous Assertion
  (metadata_length > 0) failed bug for extended msdos disklabels generated
  by Parted.
- libparted/disk_dos.c (_align_logical): also use
  _log_meta_overlap_constraint() as mandatory.
- 2005-08-21  Guillaume Knispel <k_guillaume@libertysurf.fr>
- libparted/unit.c (parse_chs, ped_unit_parse_custom): set *range to NULL
  and *sector to 0 on failure.
- parted/ui.c (command_line_get_sector): set *value to 0 on failure.
- parted/parted.c (do_mkpart, do_mkpartfs, do_move, do_resize): more memory
  leak fixes (range_start, range_end).

  [parted-1.6.24-1]
- 2005-08-10  Leslie Polzer <leslie.polzer@gmx.net>
- parted/ui.c: updated wording of bug reporting instructions
- 2005-08-09  Leslie Polzer <leslie.polzer@gmx.net>
  Applied patch from Eduardo Righes <eduardo@tteng.com.br>, HP Brazil:
- include/parted/disk.h: hidden partitions support and command to set MS
  Reserved partitions through "set" command
- libparted/disk.c: hidden partitions support and command to set MS
  Reserved partitions through "set" command
- libparted/disk_gpt.c: hidden partitions support and command to set MS
  Reserved partitions through "set" command
- 2005-08-08  Leslie Polzer <leslie.polzer@gmx.net>
- parted/parted.c (do_resize): fixed memory leak (range_start, range_end)
- 2005-08-03  Guillaume Knispel <k_guillaume@libertysurf.fr>
- libparted/disk_dos.c (msdos_partition_destroy): leak correction, free
  ((DosPartitionData*)(part->disk_specific))->orig if necessary.
- libparted/fs_fat/traverse.c (fat_traverse_complete): leak correction, free
  trav_info->dir_name.
- libparted/linux.c (_device_get_sector_size): preassign sector_size to
  PED_SECTOR_SIZE to make Valgrind happy.
- parted/ui.c (command_line_get_sector): set *range to NULL in case of failure.
- 2005-08-01  Guillaume Knispel <k_guillaume@libertysurf.fr>
- libparted/disk_dos.c (probe_partition_for_geom): integer only calculation
  of cyl_size and head_size, to avoid FP arithmetic approximation problems.
- doc/API: fixed documentation for PedUnit according to new prototypes.
- 2005-07-26  Leslie Polzer <leslie.polzer@gmx.net>
- parted/ui.c (command_line_get_sector): set range in default case
- 2005-07-19  Guillaume Knispel <k_guillaume@libertysurf.fr>
- all files: FSF address changed to
  51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
- 2005-07-11  Guillaume Knispel <k_guillaume@libertysurf.fr>
- libparted/fs_hfs/*: cosmetic changes in ped_exception_throw calls.
- libparted/fs_hfs/journal.c: added.
- libparted/fs_hfs/journal.h: added.
- libparted/fs_hfs/Makefile.am: journal.c and journal.h added.
- libparted/fs_hfs/cache.h: new tags for journal info block (CR_BTREE_CAT_JIB)
  and journal (CR_BTREE_CAT_JL)
- libparted/fs_hfs/hfs.h: journal structs (HfsJJournalInfoBlock, 
  HfsJJournalHeader, HfsJBlockInfo, HfsJBlockListHeader) described.
  HFSJ_JOURN_IN_FS, HFSJ_JOURN_OTHER_DEV, HFSJ_JOURN_NEED_INIT,
  HFSJ_HEADER_MAGIC, HFSJ_ENDIAN_MAGIC, HFSX_CASE_FOLDING, HFSX_BINARY_COMPARE
  added.
  Fields dirty_alloc_map, allocation_file, jib_start_block, jl_start_block of
  HfsPPrivateFSData added.
- libparted/fs_hfs/hfs.c (hfsplus_open): allocate dirty_alloc_map and open
  allocation_file. Do not emit the warning exception about untested attributes
  file anymore.
  (hfsplus_close): free dirty_alloc_map and close allocation_file.
  New HFSX descriptors hfsx_ops && hfsx_type.
  (ped_file_system_hfs_init, ped_file_system_hfs_done): (un)register HFSX.
- libparted/fs_hfs/reloc.c (hfs_effect_move_extent): don't save the allocation
  map anymore.
  (hfs_move_extent_starting_at): save it here.
- libparted/fs_hfs/reloc_plus.c (hfsplus_do_move): handle journal and bitmap 
  reloc.
  (hfsplus_move_extent_starting_at): call to the new hfsplus_save_allocation
  added.
- libparted/fs_hfs/probe.c, libparted/fs_hfs/probe.h: hfsx_probe added.
- libparted/disk_mac.c (mac_partition_set_system): HFSX support.
- doc/parted.texi: updated documentation to reflect new journaled and hfsx
  capabilities.
- 2005-07-10  Andrew Clausen <clausen@gnu.org>
- libparted/disk.c (_partition_check, _partition_check_extended): replaced
  a specific start<=end sanity check in _partition_check_extended with
  a generic assertion in _partition_check.
- libparted/parted.c (_ped_abs, _solution_check_distant, _get_left_bound,
  _get_right_bound, _grow_over_small_freespace): removed and replaced with
  snap_to_boundaries() et al:
- libparted/parted.c (snap_to_boundaries, try_snap, snap): these functions
  do similar things to the functions above that they replace, except that
  they constrain themselves by the recently introduced unit-specific ranges
  rather than "small" magic numbers.  In addition, it will snap to an
  existing partition boundary to avoid consuming slightly more free space.
  (So, it could possibly shrink or grow)
- libparted/disk.c (ped_disk_add_partition, ped_disk_set_partition_geom):
  these functions now deduce if a there are no constraint solutions because of
  overlapping problems, and throws an appropriate exception.  This means
  that lots of "Unable to satisfy constraints" messages will be replaced
  with "Can't have overlapping partitions" messages where appropriate.
- po/pl.po: updated.

* Wed Jul  6 2005 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.23-1]
- 2005-07-06  Andrew Clausen <clausen@gnu.org>
- po/POTFILES.in: added libparted/fs_hfs/* and libparted/unit.c.
- po/vi.po: added (thanks to Tran Thi Hoang Quyen!)
- configure.in: added vi (Vietnamese) to the language list.
- po/ja.po po/nl.po: updated.

- 2005-07-04  Andrew Clausen <clausen@gnu.org>
- include/parted/natmath.h (ped_div_round_to_nearest): added.
- libparted/unit.c (ped_unit_parse_custom, geometry_from_centre_radius):
  move out-of-disk detection into geometry_from_centre_radius(), because
  the tolerance level depends on the radius.
- libparted/unit.c (ped_unit_parse_custom): clip the sector inside the
  disk, if it passed the geometry_from_centre_radius() tolerance check.
- libparted/unit.c (ped_unit_format_custom): round to the nearest unit.
- libparted/unit.c (ped_unit_format_custom): format cylinders separately,
  because they shouldn't be rounded.
- libparted/unit.c (ped_unit_parse_custom): start counting at -1, so that
  -0 is past the end of the disk.
- libparted/constraint.c (ped_constraint_solve_nearest): it is not a bug
  to have no end solution.
- libparted/constraint.c (_constraint_get_end_range): fixed an out-by-1
  error on the length sanity check.
- libparted/unit.c (ped_unit_parse_custom): reduce the radius by 1.
  This means a location is fuzzy only to strictly less than the unit
  size.

- 2005-07-03  Andrew Clausen <clausen@gnu.org>
- include/parted/unit.h: rearranged the order of prototypes, and changed
  some formatting.
- libparted/unit.c (ped_unit_get_size, get_sectors_per_cent, remove_punct):
  rearranged order of functions.
- libparted/unit.c (ped_unit_format_custom): rewrote more compactly,
  using ped_unit_get_name().
- libparted/unit.c (parse_chs, ped_unit_parse_custom): moved CHS parsing
  into a new separate function.
- libparted/unit.c (parse_unit_suffix, ped_unit_parse_custom): moved
  the unit parsing code into a separate new function.
- libparted/unit.c (ped_unit_parse_custom): restructed error handling.
- libparted/unit.c (ped_unit_get_size): make % simple: length*SECTOR_SIZE/100
- libparted/parted.c: applied a patch by Benno Schulenberg to clean up
  error message / UI text strings.

- 2005-07-02  Leslie Polzer <leslie.polzer@gmx.net>
- libparted/unit.c: fixed off-by-one error
- doc/parted.texi: removed passage on ``='' notation and changed it
  to document the new range handling.

- 2005-07-01  Leslie Polzer <leslie.polzer@gmx.net>
- libparted/unit.c: moved handling of negative locations to the right
  place.

- 2005-06-30  Leslie Polzer <leslie.polzer@gmx.net>
- include/parted/unit.h (ped_unit_format): changed signature (swapped
  order of arguments).
- include/parted/unit.h (ped_unit_format_custom): changed signature to
  match new API interface.
- include/parted/unit.h (ped_unit_parse): changed signature to match
  new API
  interface (added range argument).
- include/parted/unit.h (ped_unit_parse_custom): changed signature to
  match new API (added ``range'' argument)
- include/parted/unit.h (ped_unit_get_size): added.
- parted/parted.c: fixed typo in help ("MUMBER").
- parted/parted.c (_solution_check_distant): changed calls to match new
  ped_unit_format signature.
- parted/parted.c (_grow_over_small_freespace): removed handling of
  is_start_exact and is_end_exact.
- parted/parted.c (do_mkpart, do_mkpartfs, do_move, do_resize): changed
  calls to command_line_get_sector and constraint_from_start_end to match
  new signatures.
- parted/parted.c (do_move, do_print): changed calls to ped_unit_format
  to match new signature.
- parted/parted.c (do_print): changed calls to ped_unit_format_custom
  to match new signature.
- parted/ui.h (command_line_get_sector): changed signature
  (replaced ``int* is_exact'' with ``PedRange** range'')
- parted/ui.c (command_line_get_integer): changed calls to
  ped_unit_format to match new signature.
- parted/ui.c (command_line_get_sector): removed handling of
  is_start_exact and is_end_exact and changed signature accordingly.
- libparted/unit.c: added API documentation.
- libparted/unit.c (ped_unit_format): rewrote call to
  ped_unit_format_custom to match new signature.
- libparted/unit.c: (clip): added.
- libparted/unit.c (geometry_from_centre_radius): added.
- libparted/unit.c (ped_unit_parse_custom): removed differentiation
  between double and long - double should be enough.
- libparted/unit.c (ped_unit_parse_custom): vast simplification due to
  new range handling and usage of new functions
  geometry_from_centre_radius and ped_unit_get_size.
- libparted/unit.c (get_sectors_per_cent): added.
- libparted/unit.c (ped_unit_get_size): added.
- libparted/disk.c (ped_disk_check): changed calls to match new
  ped_unit_format signature.
- libparted/fs_fat/calc.c (fat_check_resize_geometry): changed calls to
  match new ped_unit_format signature.

- 2005-06-18  Andrew Clausen <clausen@gnu.org>
- libparted/constraint.c: more comments.

- 2005-06-15  Andrew Clausen <clausen@gnu.org>
- po/zh_TW: added.  From Wei-Lun Chao <chaoweilun@pcmail.com.tw>.

- 2005-06-12  Andrew Clausen <clausen@gnu.org>
- libparted/disk_dos.c (probe_partition_for_geom): some OEM partitioning
  software (?) has an out-by-one error for numbering the ending cylinder
  of partitions.  This change supresses any exceptions, and treats the
  CHS information as if the correct information had been given.

- 2005-06-11  Andrew Clausen <clausen@gnu.org>
- libparted/disk_dos.c (probe_partition_for_geom): the old code couldn't
  infer any information when the start head didn't divide the end head.

- 2005-06-04  Andrew Clausen <clausen@gnu.org>
- libparted/linux.c (init_scsi, scsi_get_product_info,
  scsi_query_product_info, read_device_sysfs_file): Use /sys to
  fetch vendor/product names before trying the deprecated ioctl,
  SCSI_IOCTL_SEND_COMMAND.  Based on a patch by Chris Lumens (thanks!)
- libparted/geom.c: added more comments.
- libparted/natmath.c: added more comments.
- libparted/constraint.c: added more comments.
- libparted/device.c: added more comments.
- libparted/timer.c: added more comments.
- libparted/filesys.c: added more comments.
- libparted/disk.c: added more comments.

- 2005-06-03  Andrew Clausen <clausen@gnu.org>
- libparted/disk_mac.c (_rawpart_is_active): empty partition names with
  the type "Apple_Free" can also be free space partitions.

- 2005-06-02  Andrew Clausen <clausen@gnu.org>
- libparted/fs_fat/fat.c (fat_check): typecast -1 to (FatCluster).  (gcc
  complains otherwise)
- libparted/linux.c (init_ide): call strip_name() on the prepared buffer
  rather than the raw input.

- 2005-05-14  Andrew Clausen <clausen@gnu.org>
- libparted/fs_fat/fat.c (fat_check): don't complain about the information
  sector reporting the number of free clusters as -1 ("I don't know").

- 2005-05-10  Andrew Clausen <clausen@gnu.org>
- libparted/disk_mac.c (mac_partition_set_flag): put curly braces around
  the if body in the PED_PARTITION_BOOT case.

- 2005-04-20  Andrew Clausen <clausen@gnu.org>
- libparted/disk_mac.c (_rawpart_is_active): treat Apple_Free partitions
  with names other than Extra as normal (active) partitions.
- parted/parted (do_resize): allow resizing of extended partitions,
  even if some logical partitions are mounted.

- 2005-03-29  Andrew Clausen <clausen@gnu.org>
- everything: more punctuation / grammatical fixes from Benno Schulenberg
  <benno@nietvergeten.nl>.
- libparted/disk_dvh.c (_handle_no_volume_header): only give a lax
  constraint on the new volume header.  (Previously, if there wasn't
  much space, then the volume header would not be created.  Now, a smaller
  one gets created.)
- libparted/disk_dvh.c (_parse_partition, _generate_partition): retire the
  hack in which the start of the volume header was temporarily represented
  as 1 rather than 0.
- libparted/disk_dvh.c (_get_strict_extended_constraint): added.
- libparted/disk_dvh.c (dvh_partition_align): allow the volume header
  (extended partition) to begin on sector 0 in both strict and lax
  constraint forms.
- libparted/disk_dvh.c (dvh_alloc_metadata): only protect the partition
  table with a metadata partition if the volume header (extended partition)
  does not protect it already.
- libparted/disk_dvh.c (dvh_alloc_metadata): always protect the partition
  table, but use a logical metadata partition if the volume header
  includes the partition table.

- 2005-03-28  Andrew Clausen <clausen@gnu.org>
- everything: more punctuation / grammatical fixes from Benno Schulenberg
  <benno@nietvergeten.nl>.
- everything: filesystem -> file system.  (messages / comments only)
- parted/parted.c (init_commands): describe "=" notation.
- doc/parted.texi: describe "=" notation.
- doc/parted.texi: link www.namesys.com/pub/libreiserfs

- 2005-03-27  Andrew Clausen <clausen@gnu.org>
- parted/parted.c (_rescue_add_partition()): fixed memory leaks.
- parted/parted.c (_rescue_pass()): now accepts partitions that end within
  the allowed end range.  (Was previously buggy.)
- parted/parted.c (_rescue_add_partition()): use ped_constraint_exact()
  to force the partition geometry to match the probed filesystem's
  geometry.
- libparted/unit.c, doc/parted.texi: changes units to match SI standards.
  eg: Mb -> MB, Kb -> kB.
- libparted/libparted.c (init_disk_types, done_disk_types): put in
  alphabetical order.
- parted/ui.c parted/ui.h (command_line_get_integer, command_line_get_sector,
  command_line_get_state, command_line_get_device, command_line_get_disk,
  command_line_get_partition, command_line_get_fs_type,
  command_line_get_disk_type):
  all command_line_get_*() functions now take their default input value from
  the same location as the output value.
- parted/ui.c (command_line_get_sector): "=" specifies that the user
  would like the partition to be exactly in that location, without
  any possibility of being moved due to alignment or other reasons.
- parted/parted.c (do_check, do_cp, do_mklabel, do_mkfs, do_mkpart,
  do_mkpartfs, do_move, do_name, do_print, do_rescue, do_resize, do_rm,
  do_select, do_set): updated to new ui.h interface.
- parted/parted.c (do_name): include the old name as default.
- everything: applied many punctuation / grammatical fixes from
  Benno Schulenberg <benno@nietvergeten.nl>.

- 2005-03-21  Andrew Clausen <clausen@gnu.org>
- libparted/disk_mac.c (mac_partition_set_flag, _rawpart_is_lvm):
  Now uses "Linux_LVM" in the system name, not "lvm" in the volume name.
- libparted/disk_mac.c (mac_partition_set_flag, _rawpart_is_raid,
  _rawpart_analyse): Added analogous support for RAID partitions.
- libparted/unit.c (ped_unit_parse_custom): throw an exception if the
  location doesn't have any numbers as input.
- parted/parted.c (do_print): remove padding spaces from text, and replace
  them with numbers.  This should make life easier for the translation
  team.

- 2005-03-20  Andrew Clausen <clausen@gnu.org>
- include/parted/unit.h: added.
- include/parted/parted.h: now includes unit.h.
- include/parted/device.h: PED_SECTOR_SIZE is now defined in unit.h.
- libparted/unit.c: added.
- libparted/disk.c (ped_disk_check): use new unit.h formatting code.
- libparted/fs_fat/calc.c (fat_check_resize_geometry): use new unit.h
  formatting code.
- parted/parted.c (do_unit): added a command for selecting the default unit.
- parted/parted.c (_solution_check_distant): uses new unit.h formatting code.
  The prototype changed to include "dev", which is required to format the "%"
  and "cyl" units.
- parted/parted.c (partition_print, do_print, _rescue_add_partition):
  uses new unit.h formatting code.
- parted/parted.c (do_print): changed "Minor" -> "Number".
- parted/ui.c (command_line_get_sector): changed to use new unit.h
  parsing and formatting code.
- parted/ui.c (command_line_get_unit): added.
- parted/ui.h: added command_line_get_unit() prototype.
- doc/API: added documentation for PedUnit.
- parted/parted.c: updated help text to reflect change from Minor to Number.
- doc/parted.texi: update documentation to reflect change from Minor to Number.
- doc/parted.texi: update documentation to reflect units changes.
- include/parted/unit.h: added CHS support.  (PED_UNIT_CHS)
- libparted/unit.c: added CHS support.
- parted/parted.c: display the size of partitions, except if the unit is CHS.

* Mon Mar 21 2005 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.22-1]
- libparted/fs_fat/fat.h:  Change name to a char array in _FatDirEntry.
- libparted/fs_fat/traverse.c (fat_dir_entry_is_active): One last unsigned
  char vs. char compiler warning fix.
- libparted/device.c:  Functions named things like read, write, and check
  can be implemented as macros which will get expanded here and cause
  problems.  Surround the names with parentheses to prevent macro expansion.
- libparted/linux.c (_mount_table_search):  Ignore sccanf result.
- libparted/fs_hfs/hfs.c, libparted/fs_hfs/reloc.c,
  libparted/fs_hfs/reloc_plus.c: Make use of ped_geometry_sync_fast in hfs
  and hfs+ code.
- libparted/disk_amiga.c, libparted/disk_gpt.c, libparted/disk_pc98.c,
  libparted/disk_sun.c, libparted/linux.c, libparted/fs_hfs/reloc.c:  Fix up
  unsigned char vs. char compiler warnings.
- libparted/disk_mac.c: support LVM on PPC by setting the proper flags on the
  partition (patch from Paul Nasrat <pnasrat@redhat.com>).
- libparted/disk_sun.c: many changes, including:
	- replaced hw_geom with bios_geom.
	- disk_specific->length is now set to cylinder_size * label->ncyl.
	- label->acyl is now set to 0 by default.
- doc/parted.8: changed "mips" to "dvh" to be consistent with the Parted
  user interface.
- doc/parted.texi: added http:// and ftp:// onto some URLs.
- libparted/fs_fat/context.c: fix casting typo.
- include/parted/constraint.h, libparted/constraint.c: remove
  ped_constraint_none that wasn't being referenced anywhere.
- libparted/fs_fat/count.c (flag_traverse_fat): in the assignment to
  cluster_info [clst].units_used, store 0, rather than 64.  The code
  has the same semantics, but no gcc4 compiler warning.  (0 == 64 when
  you use 6-bit integers; 0 is interpreted as 64 in all relevant code)
  (problem reported by Chris Lumens <clumens@redhat.com>)
- libparted/fs_hfs/hfs.c (hfs_resize): do nothing when nothing to do.
- libparted/fs_hfs/hfs.c (hfsplus_resize): do nothing when nothing to do.
- libparted/fs_hfs/hfs.c (hfsplus_open): leak in the error handling code
  corrected.
- include/parted/device.h (_PedDeviceArchOps): field sync_fast added.
- include/parted/device.h (ped_device_sync_fast): added.
- include/parted/geom.h (ped_geometry_sync_fast): added.
- libparted/device.c (ped_device_sync_fast): added.
- libparted/geom.c (ped_geometry_sync_fast): added.
- libparted/gnu.c (gnu_dev_ops): sync_fast pointing to gnu_sync added.
- libparted/linux.c (linux_sync_fast): added.
- libparted/linux.c (linux_dev_ops): sync_fast pointing to linux_sync_fast
  added.
- doc/API : new ped_device_sync_fast and ped_geometry_sync_fast API
  documented.
- parted/parted.c : on the help for the mkfs, mkpart, and resize commands,
  only list filesystem types that are supported
- integrated HFS Patch 16 :
- libparted/fs_hfs/hfs.c
- libparted/fs_hfs/hfs.h
- libparted/fs_hfs/probe.c
- libparted/fs_hfs/probe.h
- libparted/fs_hfs/cache.c
- libparted/fs_hfs/cache.h
- libparted/fs_hfs/advfs.c
- libparted/fs_hfs/advfs.h
- libparted/fs_hfs/file.c
- libparted/fs_hfs/file.h
- libparted/fs_hfs/reloc.c
- libparted/fs_hfs/reloc.h
- libparted/fs_hfs/advfs_plus.c
- libparted/fs_hfs/advfs_plus.h
- libparted/fs_hfs/file_plus.c
- libparted/fs_hfs/file_plus.h
- libparted/fs_hfs/reloc_plus.c
- libparted/fs_hfs/reloc_plus.h
- libparted/Makefile.am : modified according new source files listed above
- libparted/disk_mac.c (mac_partition_set_system): tag partition with type
  "Apple_HFS" if the filesystem is "hfs+" in addition to "hfs"
- debug/test/test_fs_hfs : new non-regression tests for hfs
- debug/test/test_fs_hfsplus : new non-regression tests for hfs+
- debug/test/test (ped_test_get_val): allow bash evaluation of $post_command
- doc/parted.texi (Supported File Systems): added resize operation for hfs
  and hfs+, and a note stating they can only be made smaller.
- doc/parted.texi (Command explanation Resize): talk about hfs.

  [parted-1.6.21-1]
- libparted/disk.c, doc/parted.texi : renamed prep-boot prep partition name to
  prep.
- libparted/linux.c (linux_disk_commit): if the BLKPG method fails, try
  the BLKRRPART method.
- libparted/disk_dos.c (msdos_write): put in a unique identifier (which
  is misleadingly called the "MBR signature" by Microsoft docs and
  EFI specs).  Based on a patch by Matt Domsch <Matt_Domsch@dell.com>.
- include/parted/endian.h : fixed PED_SWAP macros missing (), since it broke
  on 64bit hardware as shown in the PED_CPU_TO_BE32(part ? part_num : LINK_END)
  code snipplet, which applied the uint32 cast to part, and not the value.
- libparted/disk_amiga.c, libparted/fs_amiga/amiga.c : Added some uint32 casts.
- libparted/disk_sun.c (sun_alloc, sun_read, sun_write): fixed
  cylinder recording stuff.  pcylcount is now 2 more, and ncyl is now
  2 less than it was before.
- libparted/filesys.c (ped_file_system_clobber): removed a useless
  (always-thrown) assertion for file system support for clobbering.
- libparted/gnu.c (gnu_new): Added three new variables ro_err, rw_err and
  ispath.  The ispath variables is set to 1 if path is indeed a path and not a
  store type name.  This prevents having to use strchr more then once.  Added
  a check for determining if the inputted path is a path and not a store-type
  name.  If (const char *)path is a path then use store_open (). If (const
  char *)path is a store-type name use store_typed_open ().
- libparted/linux.c (_disk_sync_part_table): removed duplicate error message.
- libparted/linux.c (_device_get_part_path): only treat the device as
  devfs if it has /disc on the end.
- libparted/linux.c (_partition_get_part_dev): added.
- libparted/linux.c (_partition_is_mounted_by_dev ): added.
- libparted/linux.c (_partition_is_mounted): now uses
  _partition_is_mounted_by_dev().  This is more reliable than guessing
  the partition's device name.
- libparted/linux.c (_device_probe_type): sets the type to
  PED_DEVICE_UNKNOWN on block devices that don't fall into the
  standard categories.  This makes libparted correctly update
  the kernel's view of partition tables, etc.
- libparted/disk_dos.c (probe_partition_for_geom): improved heuristic
  for finding broken partition tables: test if any feasible solution
  geometry exists against the end cylinder rather than 1024.  This
  heuristic now has fewer false negatives and no false positives.

  [parted-1.6.20-1]
- libparted/disk_dos.c (msdos_probe): look for SBML signature at offset 0x40,
  rather than 0x39.  (oops!)
- libparted/disk_amiga.c: added (from Sven Luther)
  Note: I did some cleanups, added assertions, etc.
- libparted/fs_amiga/affs.c: added.
- libparted/fs_amiga/affs.h: added.
- libparted/fs_amiga/amiga.c: added.
- libparted/fs_amiga/amiga.h: added.
- libparted/fs_amiga/apfs.c: added.
- libparted/fs_amiga/apfs.h: added.
- libparted/fs_amiga/asfs.c: added.
- libparted/fs_amiga/asfs.h: added.
- libparted/fs_amiga/interface.c: added.
- libparted/disk_dos.c (msdos_probe): Fixed typo changed strcmp to
  strncmp.
- libparted/disk_dvh.c (_generate_boot_file): zero out the boot file name
  record before writing the name in.  Previously, there was a misplaced
  null-terminator that caused gcc to complain.
- libparted/filesys.c (ped_file_system_resize, ped_file_system_copy):
  only attempt to check file systems if checking is implemented for
  that file system type.
- libparted/fs_fat/bootsector.c (fat_boot_sector_analyse): when correcting
  the boot sector, use fat_boot_sector_write() to make sure the backup
  copy gets written (if applicable).
- libparted/disk_dos.c (msdos_probe): don't treat Smart Boot Manager Loader
  boot blocks as FAT file systems.
- libparted/disk_dos.c: Added support for the prep-boot partition type.


* Fri Nov 29 2004 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.19-1]
- libparted/fs_fat/boot_sector.c (fat_boot_sector_analyse): if the
  file system's CHS geometry is insane, then let the user fix it.
  This is important, because Linux refuses to mount FAT file systems
  with insane CHS geometry.  Moreover, a few recent versions of Parted
  wrote some insane values here, so this allows users to fix the damage.
- parted/ui.c (_construct_prompt): previously forget to assign "prompt = ..."
  in a realloc_and_cat() call.  Patch from Woody Suwalski <woodys@xandros.com>
- libparted/linux.c (linux_new): get rid of pointless exception for
  exotic block devices.
- configure.in, libparted/fs_reiserfs/reiserfs.c (reiserfs_fs_check):
  applied patch by Yury to do a proper file system check.

* Fri Nov 19 2004 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.18-1]
- libparted/disk_dos.c (probe_partition_for_geom): don't attempt to infer
  geometry from a partition whose end can't possibly be addressed with CHS
  (regardless of the CHS geometry).
- libparted/disk_dos.c (msdos_read): initialize bios_geom to the old value,
  in case no better geometry can be found.

* Fri Nov 19 2004 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.17-1]
- libparted/fs_fat/resize.c (create_resize_context): copy CHS info across.
  (Was previously uninitialized - bug)
- libparted/disk_dos.c (msdos_partition_set_system): sun-ufs partitions
  now have an ID of 0xbf.
- libparted/disk_dos.c (probe_partition_for_geom): rewrote with lots
  more comments + mathematical paranoia.
- libparted/disk_dos.c (realloc_metadata, msdos_read): better solution...
  just call msdos_read() again if the CHS geometry needs to be changed.
- libparted/disk_gpt.c (write_pmbr): if the partition is longer than
  32-bits can fit, then write 0xffffffff as per GPT spec.  Patch from
  Matt Domsch <Matt_Domsch@dell.com>.

  [parted-1.6.16-1]
- libparted/disk_dos.c (realloc_metadata): stupid bug fix: reset the start/end
  to be the same as what they were before.
- libparted/disk_dos.c (probe_partition_for_geom): ignore CHS geometry
  if the start cylinder is greater than the end cylinder.
- libparted/fs_fat/bootsector.h: add another __attribute__ ((packed))
  thingy to ensure the right alignment.
- parted/parted.c (do_print, _rescue_add_partition): removed bogus
  (int) casts.  (%f, what was I thinking?!)

* Mon Sep 20 2004 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.15-1]
- libparted/disk_dos.c: replaced magic number 1023 with MAX_CHS_CYLINDER,
  and set this constant to >1021 rather than >=1023.  Some partition tables
  in the wild have 1022 as a "partition-too-big-for-CHS" indicator.
- libparted/gnu.c (_device_probe_geometry): Variable declaration had
  wrong name.
- libparted/disk_dos.c (realloc_metadata, read_table): added an ugly hack to
  force metadata to be reallocated according to the new BIOS geometry.
- libparted/disk_dos.c (msdos_alloc_metadata): yet another overlapping case
  I missed: the extended partition's partition table area needs to be
  small enough to leave room for the logical partition (or logical partition
  table) that follows it.
- libparted/linux.c (linux_check): s/int/PedSector/ to be on the safe side.
- libparted/gnu.c (_device_probe_geometry): fixed compile bug with the
  bios_geom initialization, and now initializes hw_geom as well.

* Tue Sep  7 2004 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.14-1]
- released 1.6.14

  [parted-1.6.13-1]
- libparted/disk_dos.c (partition_probe_bios_geometry): fixed the
  call ped_partition_is_active... it wasn't a function call before!
- libparted/disk_dos.c (chs_get_sector): a bitmask operation is more elegant.
- libparted/disk_dos.c (chs_to_sector, probe_partition_for_geom):
  replaced 1022 with 1023 for consistency.
- libparted/disk_dos.c (probe_partition_for_geom): added assertions that
  test if the goal has been met.
- libparted/disk_dos.c (read_table, msdos_alloc_metadata):
  Use PED_PARTITION_NORMAL instead of 0.
- libparted/disk_dos.c (msdos_alloc_metadata, add_startend_metadata):
  Now make sure the placeholder/metadata partitions never overlap with real
  partitions.  Should get rid of the "overlapping partitions" error message
  bug.
- released 1.6.13

  [parted-1.6.12-1]
- libparted/disk_dos.c (disk_probe_bios_geometry): check if the partition
  is active before querying if it has the boot flag set.  This prevents
  some spurious error exceptions from ped_partition_get_flag().
- libparted/disk_dos.c (read_table): if we have an invalid partition table
  signature, we now ignore the entire partition table rather than processing
  dodgey data.
- doc/API: fixed PedDevice documentation.
- libparted/disk_dos.c (msdos_partition_duplicate): now duplicates
  partition->dos_data->orig.
- libparted/linux.c (_mount_table_search): now works by comparing device
  major/minor rather than device names.
- libparted/linux.c (_partition_is_mounted, _partition_is_mounted_by_path,
  linux_is_busy): minor cosmetic changes.
- parted/parted.c (_partition_warn_busy): removed the "Ignore" option.
  Users *must* unmount!
- libparted/exception.c (log2): renamed to ped_log2 to avoid clash with
  a new gcc builtin.  Bug reported by David Ronis (thanks!)
- released 1.6.12

  [parted-1.6.11-1]
- include/parted/device.h (PedDevice): replaced sectors, heads, cylinders
  with hw_geom and bios_geom.
- libparted/disk_dos.c: rewrote to use better heuristics and have a more
  "subjective" view of CHS geometry.  (i.e. each partition's "opinion"
  may differ now)
- configure.in parted/Makefile.am: fixed linker invocation.  Rumored
  to fix ppc64 build issues.  Sent by Jeremy Katz <katzj@redhat.com>.
- libparted/disk_dos.c (read_table): big cleanup
- libparted/disk_dos.c (read_table, process_bad_chs): now probes Microsoft
  file systems for BIOS CHS geometry.  This idea was suggested by
  Steffen Winterfeldt <snwint@suse.de>.
- libparted/disk_dvh.c: some cleanups and change to fill in all fields in the
  header from Eric Sandeen (sandeen@sgi.com)
- libparted/fs_fat/bootsector.c: bs->cluster_size is 8-bit; removed byteswap.
  Patch from John Gilmore gnu@toad.com (thanks!)
- libparted/debug.c include/parted/debug.h (ped_assert): change prototype
  to have all (pointer) parameters to be const.  (char* -> const char *)
- libparted/linux.c (linux_read, linux_write): don't do the kludge ioctl
  for linux >= 2.6.0.  Patch from Matt Domsch.  (Thanks!)
- libparted/fs_reiserfs/geom_dal.c, libparted/geom.c, libparted/gnu.c,
  libparted/linux.c: trivial patch to move pointers dereferences after
  "not-NULL" assertions.  Patch from Guillaume.  (Thanks!)
- released 1.6.11

* Fri Apr 16 2004 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.10-1]
- libparted/disk_mac.c (mac_alloc): fixed incorrect malloc() check
  (alex.kiernan@thus.net)
- libparted/linux.c (_device_get_sector_size): always return a sane value.
- added new translation: it (thanks to Giuseppe Sacco)
- added new translation: uk (thanks to Maxim V. Dziumanenko)

* Mon Apr  5 2004 Ryan Weaver <ryanw@falsehope.com>
- Shared Library filename was changed due to an outdated ltmain.sh.
  [parted-1.6.9-1]
- re-ran libtoolize. (Patrick LoPresti <patl@users.sf.net> pointed out that
  ltmain.sh was way out of date). Andrew Clausen <clausen@gnu.org>

* Mon Mar 29 2004 Ryan Weaver <ryanw@falsehope.com>
- Updated spec file a bit.
- Shared Library filename changed to libparted-1.6.0
  [parted-1.6.8-1]
- configure.in: removed intl/ from AC_OUTPUT

  [parted-1.6.7-1]
- libparted/disk_sun.c: avoid endian conversion on a constant (Sven Luther)
- libparted/linux.c (BLKGETSIZE64): pass type directly, not sizeof(). (Sven Luther)
- libparted/fs_reiserfs/reiserfs.h libparted/fs_ufs/ufs.c: fix padding sizes (Roman Zippel)
- include/parted/disk.h libparted/disk_dos.c: add HP palo partition type. (Richard Hirst)
- Makefile.am (SUBDIRS): Add m4.
- (SUBDIRS): Remove intl.
- (ACLOCAL_AMFLAGS): New variable.
- (EXTRA_DIST): Add config.rpath.
- configure.in (AC_OUTPUT): Add m4/Makefile.


* Mon Jul 28 2003 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.6-1]
- added new translation: zh_CN (thanks Wang Li :)
- updated translation: tr
- applied updated translations: cs, fr, ja, pl
- libparted/disk_*.c (*_partition_duplicate): added new_part->num = part->num
  or result->num = part->num.
- libparted/fs_ext2/ext2.c (ext2_open): changed "not cleanly unmounted"
  from a warning to an error, and default to cancel.  Added a message saying
  not ignoring could cause severe corruption.
- parted/parted.c (_partition_warn_busy): added a message saying not ignoring
  could cause severe corruption.
- libparted/fs_ext2/ext2_resize.c (ext2_resize): offer to disable dir_index,
  explaining how to reenable it later.
- libparted/fs_ext2/ext2_fs.h libparted/fs_ext2/ext2.c: added DIR_INDEX
  stuff... now doesn't complain too much about dir_index.
- doc/parted.texi: applied Thomas Hood's changes.  (thanks!)
- libparted/disk.c (ped_disk_get_maximum_geom): applied a tight constraint
  for restoring the geometry.  (It was loose before, and sometimes being
  reverted incorrectly.  Ooops!)
- parted/parted.c (start_end_msg): describe semantics of negative values.
- added Czech translations (thanks Miloslav :)
- updated Turkish, Danish translations
- applied new Polish translations.
- doc/parted.texi: s/mkparted/mkpart/ (Kent Robotti's program)
- libparted/disk_gpt.c: changed some large constants to LL (long long).
- parted/parted.c (do_print): translate partition type names.  ("primary", etc.)
- switched to new autoconf/automake/libtool.  This means acconfig.h was
  removed, and comments were added to AC_DEFINE invocations in configure.in.

* Mon Feb 24 2003 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.5-1]
- libparted/disk_gpt.c: applied patch from Arun Sharma <arun.sharma@intel.com>
  to use write version 1.0, not 1.02 on the table, for compatibility reasons.
  Insignificant for copyright purposes, IMHO.
- libparted/linux.c (_disk_sync_part_table): fixed an array over-run bug
  reported by Sven Hartrumpf <Sven.Hartrumpf@FernUni-Hagen.de>. Applied a
  modified version of this patch.  Insignificant for copyright purposes, IMHO.
- doc/parted.texi: fixed somes of typos and broken URLs.
- libparted/linux.c (_match_rd_device, _compare_digit_state,
  _probe_proc_partitions): added, added and modified respectively to
  match raid devices looking like /dev/rd/c0d0, which are not partitions.
- libparted/disk_dvh.c, libparted/Makefile.am, libparted/libparted.c:
  renamed from everything from mips to dvh, including the file name
  libparted/disk_mips.c.

* Sat Dec  7 2002 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.4-1]
- applied updated translations: fr, gl, tr, ja
- configure.in parted/Makefile.am partprobe/Makefile.am:
  renamed PARTED_LDFLAGS to PARTEDLDFLAGS... it was causing automake to
  do some odd things (name-space collision?)
- released 1.6.4
- libparted/fs_fat/calc.c (fat_calc_sizes, fat_recommend_min_cluster_size):
  for fat32, try to avoid getting more than 2,000,000 clusters by increasing
  the cluster size.  Otherwise, Windows coughs.
- debug/test/test_fs_ext2: added a test for creating 0-length fs
- doc/API: fixed docs for ped_disk_get_partition_by_sector() and
  ped_constraint_any()
- doc/parted.texi: updated section on bootdisks
- libparted/fs_fat/bootsector.c (fat_boot_sector_read): defined the
  role of error checking in this function better.  [It should guarantee
  fat_boot_sector_probe_type() will work].  Added a check for
  bs->cluster_size != 0) to satisfy this clarification.  (msw reported
  divide-by-zero)
- libparted/linux.c (init_file): replaced assertion dev->length > 0 with
  a check + error message.
- (_partition_is_root_device): now returns -1 ("unknown") on error
- (_partition_is_mounted_by_path): re-did the logic with case statements,
  and now remembers if /proc/mounts and /etc/mtab are broken.  Gives
  a better error message.
- parted/parted.c (do_print): removed cruft: we don't print free-space
  partitions
- applied updated translations: fr, ja
- parted/parted.c (do_mkpart): moved ped_constraint_destroy() to just
  before the return, so error handling occurs correctly.

* Mon Aug 12 2002 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.3-1]
- libparted/linux.c (_kernel_has_blkgetsize64, _device_get_length):
  applied patch from Matt Domsch that adds support for a new ioctl,
  BLKGETSIZE64
- parted/parted.c (_done): surpress the /etc/fstab advice in script mode
- updated translations: da, de, es, fr, gl
- new translations: tr (Turkish)  - thanks Eyp :)

* Mon Jul 29 2002 Ryan Weaver <ryanw@falsehope.com>
  [parted-1.6.2-1]
- Catchup RPM, many changes. See ChangeLog in docs dir.

